﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace EdgeClustering
{
    /// \author Manuel Keglevic
    /// \author Thomas Schulz
    /// <summary>
    /// This class represents a point on a 2D grid, with int coordinates x and y.
    /// </summary>
    class GridPoint : IEquatable<GridPoint>
    {
        private int x;
        public int X
        {
            get { return x; }
            set { x = value; }
        }

        private int y;
        public int Y
        {
            get { return y; }
            set { y = value; }
        }

        public GridPoint(int x, int y)
        {
            this.x = x;
            this.y = y;
        }

        /// <summary>
        /// Points are equal if they have the same coordinates.
        /// </summary>
        /// <param name="other">Another GridPoint</param>
        /// <returns>True if this GridPoint is equal to <code>other</code></returns>
        public bool Equals(GridPoint other)
        {
            if (other.x == x && other.y == y)
                return true;
            return false;
        }

        public override bool Equals(Object obj)
        {
            if (obj == null) return base.Equals(obj);

            if (!(obj is GridPoint))
                throw new InvalidCastException("The 'obj' argument is not a GridPoint object.");
            else
                return Equals(obj as GridPoint);
        }

        public override int GetHashCode()
        {
            return this.GetHashCode();
        }

    }
}
