﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections;

namespace EdgeClustering
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private Point mousePoint;
        private ScaleTransform transform;
        private Graph _graph;
        private GraphDrawer gdrawer;
        public void LoadGraph(String filename){

        }

        public void LoadRandomGraph()
        {
            _graph = new Graph(50, 20);

           
            gdrawer.Graph = _graph;


            gdrawer.InvalidateVisual();
            //_graph.Compute();
        }

        public MainWindow()
        {
            InitializeComponent();

            gdrawer = new GraphDrawer((int)canvas1.Width);
            canvas1.Children.Add(gdrawer);

            transform = new ScaleTransform();
            gdrawer.RenderTransform = transform;
            transform.CenterX = canvas1.Width / 2;
            transform.CenterY = canvas1.Height / 2;

            try
            {
                // Read settings
                XMLData.ReadSettings("Config.xml");
                UpdateGUI();
                gdrawer.InvalidateVisual();

            }
            catch (System.IO.FileNotFoundException ex)
            {
                MessageBox.Show("No \"Config.xml\" found. Save settings for next start.", "Warning", MessageBoxButton.OK, MessageBoxImage.Warning);
            }
            catch (Exception e)
            {
                MessageBox.Show("Unable to load settings from the configuration file.", "Error", MessageBoxButton.OK, MessageBoxImage.Error);
            }
            
            
            InitSettings();
        }

       

        private void IsInitialized(object sender, EventArgs e)
        {
            
        }

        private void canvas1_MouseDown(object sender, MouseButtonEventArgs e)
        {
            mousePoint = e.GetPosition(canvas1);

           
            //TransformGroup transform = new TransformGroup();

            //transform.Children.Add(new ScaleTransform(2, 2));
            //transform.Children.Add(new TranslateTransform(-p.X, -p.Y));

            //canvas1.RenderTransform = transform;
        }

        private void canvas1_MouseUp(object sender, MouseButtonEventArgs e)
        {
            
            //canvas1.RenderTransform = new MatrixTransform();
            //Vector delta = (e.GetPosition(canvas1) - mousePoint);

            //TransformGroup transform = new TransformGroup();
            //transform.Children.Add(canvas1.RenderTransform);
            //transform.Children.Add(new TranslateTransform(-delta.X, -delta.Y));

            //canvas1.RenderTransform = transform;
        }

        private void slider1_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            //if(mouseDown)
                
            transform.ScaleX = e.NewValue;
            transform.ScaleY = e.NewValue;
        }

        private void Window_PreviewMouseWheel(object sender, MouseWheelEventArgs e)
        {
            int d = (Math.Sign(e.Delta)> 0)?1:-1;

            
            transform.ScaleX += d;
            transform.ScaleY += d;

            if (transform.ScaleX < 1)
                transform.ScaleX = 1;
            if (transform.ScaleY < 1)
                transform.ScaleY = 1;
        }

        private void Window_MouseMove(object sender, MouseEventArgs e)
        {
            
            Point current =  e.GetPosition(canvas1);
            //if (!mouseDown)
            //{
               

                if ( !(current.X > canvas1.Width))
                {
                    transform.CenterX = current.X;
                    transform.CenterY = current.Y;
                }

            //}
            //else
            //{
                //_graph.MoveControlMeshVertex(mousePoint, current - mousePoint);

            //}

            mousePoint = e.GetPosition(canvas1);
        }

        private void GraphImport_Click(object sender, RoutedEventArgs e)
        {
            // Configure open file dialog box
            Microsoft.Win32.OpenFileDialog dlg = new Microsoft.Win32.OpenFileDialog();
            dlg.FileName = "Graph"; // Default file name
            dlg.DefaultExt = ".xml"; // Default file extension
            dlg.Filter = "XML Graph (.xml)|*.xml"; // Filter files by extension

            // Show open file dialog box
            Nullable<bool> result = dlg.ShowDialog();

            // Process open file dialog box results
            if (result == true)
            {
                // Open document
                string filename = dlg.FileName;
                _graph = new Graph(filename);
            }

            gdrawer.Graph = _graph;
            gdrawer.InvalidateVisual();
        }

        private void LoadConfig_Click(object sender, RoutedEventArgs e)
        {
            // Configure open file dialog box
            Microsoft.Win32.OpenFileDialog dlg = new Microsoft.Win32.OpenFileDialog();
            dlg.FileName = "Config"; // Default file name
            dlg.DefaultExt = ".xml"; // Default file extension
            dlg.Filter = "XML Graph (.xml)|*.xml"; // Filter files by extension

            // Show open file dialog box
            Nullable<bool> result = dlg.ShowDialog();

            // Process open file dialog box results
            if (result == true)
            {
                try {
                    // Read settings
                    XMLData.ReadSettings(dlg.FileName);
                }
                catch (Exception ex)
                {
                    MessageBox.Show("Unable to load settings from the configuration file.", "Error", MessageBoxButton.OK, MessageBoxImage.Error);
                }
            }

            UpdateGUI();
            gdrawer.InvalidateVisual();
        }

        private void SaveConfig_Click(object sender, RoutedEventArgs e)
        {
            Microsoft.Win32.SaveFileDialog dlg = new Microsoft.Win32.SaveFileDialog();
            dlg.FileName = "Config"; // Default file name
            dlg.DefaultExt = ".xml"; // Default file extension
            dlg.Filter = "XML Graph (.xml)|*.xml"; // Filter files by extension

            // Show save file dialog box
            Nullable<bool> result = dlg.ShowDialog();

            // Process save file dialog box results
            if (result == true)
            {
                ComputeButton_Click(null, null);
                try {
                    // Save settings
                    XMLData.WriteSettings(dlg.FileName);
                }
                catch (Exception ex)
                {
                    MessageBox.Show("Unable to write settings to file.", "Error", MessageBoxButton.OK, MessageBoxImage.Error);
                }
            }
        }

        private void DebugRandomGraph_Click(object sender, RoutedEventArgs e)
        {
            LoadRandomGraph();
        }

        private void SaveGraph_Click(object sender, RoutedEventArgs e)
        {
            if (_graph == null)
                return;

            Microsoft.Win32.SaveFileDialog dlg = new Microsoft.Win32.SaveFileDialog();
            dlg.FileName = "Graph"; // Default file name
            dlg.DefaultExt = ".xml"; // Default file extension
            dlg.Filter = "XML Graph (.xml)|*.xml"; // Filter files by extension

            // Show save file dialog box
            Nullable<bool> result = dlg.ShowDialog();

            // Process save file dialog box results
            if (result == true)
            {
                // Save document
                string filename = dlg.FileName;
                _graph.WriteXMLGraph(filename);
            }

           
           
        }

        private void Compute_Click(object sender, RoutedEventArgs e)
        {
            if (_graph == null)
                return;

            _graph.Compute();
            gdrawer.InvalidateVisual();
        }

        private void ComputeButton_Click(object sender, RoutedEventArgs e)
        {
            Graph.Settings.GridSize = (int)Math.Round(GridSizeSlider.Value);
            Graph.Settings.KdeRadius = KDEAngleSlider.Value;
            Graph.Settings.KdeThreshold = KDEThresholdSlider.Value;
            MergedSegment.threshold = MergeAngleSlider.Value;

            if (_graph == null)
                return;

            _graph.Compute();
            gdrawer.InvalidateVisual();
        }

        private void OriginalGraphColor_SelectedColorChanged(Color obj)
        {

            GraphDrawer.Settings.GraphColor = obj;

            gdrawer.InvalidateVisual();
        }

        private void Segments_ColorChanged(Color obj)
        {
            GraphDrawer.Settings.SegmentsColor = obj;

            gdrawer.InvalidateVisual();
        }

        private void MergedSegments_ColorChanged(Color obj)
        {
            GraphDrawer.Settings.MergedSegmentsColor = obj;
            gdrawer.InvalidateVisual();
        }

        private void KDEPeaks_ColorChanged(Color obj)
        {
            GraphDrawer.Settings.KDEPeakColor = obj;
            gdrawer.InvalidateVisual();
        }

        private void SegmentsNormal_ColorChanged(Color obj)
        {
            GraphDrawer.Settings.ControlMeshEdgesColor = obj;
            gdrawer.InvalidateVisual();
        }

        private void ControlPoints_SelectedColorChanged(Color obj)
        {
            GraphDrawer.Settings.ControlPointsColor = obj;
            gdrawer.InvalidateVisual();
        }

        private void CustomColorPicker_SelectedColorChanged(Color obj)
        {
            GraphDrawer.Settings.ControlMeshColor = obj;
            gdrawer.InvalidateVisual();
        }

        private void CustomColorPicker_SelectedColorChanged_1(Color obj)
        {
            GraphDrawer.Settings.EnhancedGraphColor = obj;
            gdrawer.InvalidateVisual();
        }
         public void InitSettings()
        {
            GridSizeSlider.Value = Graph.Settings.GridSize;
            GraphVisibleCheckbox.IsChecked = GraphDrawer.Settings.graphEdgesVisible;
            OriginalGraphColor.SelectedColor = GraphDrawer.Settings.GraphColor;
            KDEAngleSlider.Value = Graph.Settings.KdeRadius;
            KDEAngleTextBlock.Text = Graph.Settings.KdeRadius + "°";
            GridSizeTextBlock.Text = Graph.Settings.GridSize+"";
            
             KDEThresholdSlider.Value = Graph.Settings.KdeThreshold;
             KDEThresholdTextblock.Text = string.Format("{0:0.00}", KDEThresholdSlider.Value * 100) + "%";

             MergeAngleSlider.Value = MergedSegment.threshold;
             MergeAngleTextbox.Text = string.Format("{0:0}", MergeAngleSlider.Value) + "°";

            SegmentNormalsVisibleCheckbox.IsChecked = GraphDrawer.Settings.controlMeshEdgesVisible;
            KDEPeaksVisibleCheckbox.IsChecked = GraphDrawer.Settings.kernelPeaksVisible;
            MergedSegmentsVisibleCheckbox.IsChecked = GraphDrawer.Settings.mergedSegmentsVisible;
            SegmentsVisibleCheckbox.IsChecked = GraphDrawer.Settings.segmentsVisible;
            ControlPointsVisibleCheckbox.IsChecked = GraphDrawer.Settings.controlPointsVisible;
            ControlMeshVisibleCheckbox.IsChecked = GraphDrawer.Settings.controlMeshVisible;
            EnhancedGraphVisibleCeckbox.IsChecked = GraphDrawer.Settings.enhancedGraphVisible;

            SettingsCanvas.InvalidateVisual();
        }

        private void GraphVisibleCheckbox_Click(object sender, RoutedEventArgs e)
        {
            GraphDrawer.Settings.graphEdgesVisible = (GraphVisibleCheckbox.IsChecked == true);
            gdrawer.InvalidateVisual();
        }

        private void SegmentsVisibleCheckbox_Click(object sender, RoutedEventArgs e)
        {
            GraphDrawer.Settings.segmentsVisible = (SegmentsVisibleCheckbox.IsChecked == true);
            gdrawer.InvalidateVisual();
        }

        private void MergedSegmentsVisibleCheckbox_Click(object sender, RoutedEventArgs e)
        {
            GraphDrawer.Settings.mergedSegmentsVisible = (MergedSegmentsVisibleCheckbox.IsChecked == true);
            gdrawer.InvalidateVisual();
        }

        private void KDEPeaksVisibleCheckbox_Click(object sender, RoutedEventArgs e)
        {
            GraphDrawer.Settings.kernelPeaksVisible = (KDEPeaksVisibleCheckbox.IsChecked == true);
            gdrawer.InvalidateVisual();
        }

        private void SegmentNormalsVisibleCheckbox_Click(object sender, RoutedEventArgs e)
        {
            GraphDrawer.Settings.controlMeshEdgesVisible = (SegmentNormalsVisibleCheckbox.IsChecked == true);
            gdrawer.InvalidateVisual();
        }

        private void ControlPointsVisibleCheckbox_Click(object sender, RoutedEventArgs e)
        {
            GraphDrawer.Settings.controlPointsVisible = (ControlPointsVisibleCheckbox.IsChecked == true);
            gdrawer.InvalidateVisual();
        }

        private void ControlMeshVisibleCheckbox_Click(object sender, RoutedEventArgs e)
        {
            GraphDrawer.Settings.controlMeshVisible = (ControlMeshVisibleCheckbox.IsChecked == true);
            gdrawer.InvalidateVisual();
        }

        private void EnhancedGraphVisibleCeckbox_Click(object sender, RoutedEventArgs e)
        {
            GraphDrawer.Settings.enhancedGraphVisible = (EnhancedGraphVisibleCeckbox.IsChecked == true);
            gdrawer.InvalidateVisual();
        }

        private void GridSizeSlider_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            if (GridSizeTextBlock != null)
                GridSizeTextBlock.Text = string.Format("{0:0}", GridSizeSlider.Value);
        }

        private void KDEAngleSlider_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            if (KDEAngleTextBlock != null)
            {
                KDEAngleTextBlock.Text = string.Format("{0:0}", KDEAngleSlider.Value)+"°";
               
            }

            //Graph.Settings.KdeRadius = KDEAngleSlider.Value;

            //if (_graph != null)
            //{
            //    _graph.Compute();
            //    gdrawer.InvalidateVisual();
            //}
        }

        private void KDEThresholdSlider_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            if (KDEThresholdTextblock != null)
                KDEThresholdTextblock.Text = string.Format("{0:0.00}", KDEThresholdSlider.Value*100) + "%";
        }

        private void MergeAngleSlider_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            if (MergeAngleTextbox != null)
                MergeAngleTextbox.Text = string.Format("{0:0}", MergeAngleSlider.Value) + "°";
        }

        private void UpdateGUI()
        {
            GraphVisibleCheckbox.IsChecked = GraphDrawer.Settings.graphEdgesVisible;
            SegmentsVisibleCheckbox.IsChecked = GraphDrawer.Settings.segmentsVisible;
            SegmentNormalsVisibleCheckbox.IsChecked = GraphDrawer.Settings.graphEdgesVisible;
            EnhancedGraphVisibleCeckbox.IsChecked = GraphDrawer.Settings.enhancedGraphVisible;
            MergedSegmentsVisibleCheckbox.IsChecked = GraphDrawer.Settings.mergedSegmentsVisible;
            KDEPeaksVisibleCheckbox.IsChecked = GraphDrawer.Settings.kernelPeaksVisible;
            ControlPointsVisibleCheckbox.IsChecked = GraphDrawer.Settings.controlPointsVisible;
            ControlMeshVisibleCheckbox.IsChecked = GraphDrawer.Settings.controlMeshVisible;

            GridSizeSlider.Value = Graph.Settings.GridSize;
            KDEAngleSlider.Value = Graph.Settings.KdeRadius;
            KDEThresholdSlider.Value = Graph.Settings.KdeThreshold;
            MergeAngleSlider.Value = MergedSegment.threshold;
        }

       

        

      

       

       

  

 
       

    }
}
